### Create


**1. Git availability and performance:** Git is a critical component in the deployment process when practicing Continuous Deployment. As such, service degradations or outages that prevent access to Git cannot be tolerated. To this end, making [Gitaly highly available](https://gitlab.com/groups/gitlab-org/-/epics/842) is of the utmost importance, and secondarily, improve the handling of extreme read pressures exterted by highly parallelized CI loads that cause performance degradations.

Growth driver: Initial purchase

**2. Provide a great experience for large repositories and monorepos:** To gather more market share from industries that currently use Perforce or SVN, or from customers that just have huge monorepos, we must invest in making the [large repository experience](https://gitlab.com/groups/gitlab-org/-/epics/773) in Git excellent. Large files should “just work” without configuration or specialized hardware. We will primarily be focused on partial clone, but also provide support for sparse checkouts.

Growth driver: Initial purchase

**3. Enhancing the code review experience:** In the next 12 months, we must focus code review to be more performant and intelligent. We will do this by investing in [performance improvements](https://gitlab.com/groups/gitlab-org/-/epics/1417), adding additional code review functionality such as jump to definition, identifying references, displaying function documentation and type signatures, and adding support for first-class reviewers. Code review should be an "IDE like" experience. Additionally, we should invest in enhancing language specific experiences such as improving syntax highlighting and webpacks. The Merge Request is a point of unification in the product and provides experiences for pipeline results, security scans, code review, discussions, and branching. As such, it's incredibly important that we care about the UX, performance, and usability of this object.

Growth driver: Retention

**4. Realtime Merge Requests:** Many parts of GitLab update in near realtime, but not everything does, and unfortunately some of the parts that are left are critical to a great experience. Realtime kanban boards is mentioned above in Plan, but within Create, there is a lot of opportunity. Areas we are thinking about are real time editing of code in the Web IDE for live coding and real time editing of issue/MR descriptions and comments. For more thoughts on this topic, check out the embedded video!

<figure class="video_container">
    <iframe src="https://www.youtube.com/embed/KpdvIU6hv94" frameborder="0" allowfullscreen="true"> </iframe>
</figure>

Growth driver: Retention

**5. Focusing on the gaps in the design management workflow:** Most designers use a sketch or prototyping tool already, but version controlling assets alongside
code and providing a workflow to compare those assets to what front-end teams ship is a gap in the market. We are uniquely poised to capitalize on this gap; think
visual review apps checked against the mockups checked into the repository. Additionally, we will continue to make improvements to the collaboration aspect
of designs and consider other features such as simple sketch functionality inside of issues and MRs.

Growth driver: Expansion

**6. Bolstering the Web IDE experience:** Our current Web IDE experience is useful for small changes, but has not proven itself useful as an actual replacement for a local IDE. Over the next year we will streamline our editing experience, potentially sunsetting the ACE, single-file editor. The team will also be investing in quality of life changes, such as adapting syntax highlighting preferences, moving information to areas in the Web IDE where they would be on local editors, and providing tools for easier code creation. Additionally, we will improve the IDE experience by providing a way to [self-host](https://gitlab.com/gitlab-org/gitlab/issues/27144#note_220760431) the client side evaluation capabilities already inside of the Web IDE.

Growth Driver: Expansion

**7. Creating a static site editing experience:** Projects in GitLab aren't always leveraged by pure engineering teams. Groups like marketing, sales and others often have needs for projects that more closely resemble marketing websites or documentation. While [GitLab Pages](https://docs.gitlab.com/ee/user/project/pages/) enables the deployment of many popular static site generators, the editing experience is still geared towards technical users. Enabling a more WYSIWYG content management editor will help support non-technical personas use GitLab for non-engineering driven projecs. We'll also ensure this experience is dogfooded by our GitLab Handbook and available on both mobile and tablet devices.

Growth Driver: Expansion

**8. Code Intelligence:** Making changes to a huge code base or monorepo can be challenging
due to the sprawl of code and unknown dependencies that span it. Additionally, joining a
new orgnization and ramping up with a new codebase is hard. GitLab should provide a great
experience for code intelligence that helps contributors be more productive earlier.

Growth Driver: Expansion
